#include <Modules/focus.h>

char
*focus_options[] = {
	//0|1
	"always-click-to-focus",
	"always-click-to-raise",
	"pass-click-on",
	"focus-last-focused-per-desktop",
	"focus-revert-on-hide-or-close",
	"transient-raise",
	//mc
	"focus-policy",
	"focus-setting",
	//combo
	"use-auto-raise",
	"auto-raise-delay"
},
*_focus_options_labels[] = {
	"Always click to focus",
	"Always click to raise",
	"Pass click on",
	"Focus per Desktop",
	"Focus revert on hide/close",
	"Transient raise",
	"Focus-policy",
	"Focus-setting",
	"Auto-raise",
	"Auto-raise-delay"
},
*_focus_options_help[] = {
	"Set, if a click into window is mandatory give focus <br> ",
	"Set, if a click into window is mandatory to raise it <br> ",
	"Set, if a click into window is passed to the app <br> ",
	"Saves focussed window for each desktop <br> ",
	"Focus last focused window when hide or close a focused window <br> ",
	"Raises transients together with parents <br> ",
	"How to determine which window has focus <br> ",
	"Which new windows to focus <br> ",
	"Automatically raise windows, on mouse-over <br> ",
	"Auto-raise-delay in seconds"
};

void
focus_mc(Etk_Object *object, void* data){
	Etk_Button *button = ETK_BUTTON(object);
	setOption(data,etk_button_label_get(button));
	clicked(_focus);
}

Etk_Widget*
init_focus(){
	Etk_Widget *window,*container,*table,*o_table,*o_set1,*o_set2,*o_set3,*o_button;
	int i = 0,tmp;
	char* tmpc;
	
	window = etk_window_new();
	etk_window_title_set(ETK_WINDOW(window),"Focus Settings");
	etk_signal_connect_after("destroy",ETK_OBJECT(window),ETK_CALLBACK(sub_window_kill),NULL);
	
	container = etk_vbox_new(FALSE,3);
	etk_container_add(ETK_CONTAINER(window),container);
	
	table = etk_table_new(2,20,FALSE);
	etk_container_add(ETK_CONTAINER(container),table);
	//switches
	for (i=0;i<6;i++) {
		o_table = etk_table_new(1,1,FALSE);
		etk_table_attach(ETK_TABLE(o_table),get_prepared_toggle_button(focus_options[i]),0,0,0,0,0,0,ETK_FILL_POLICY_NONE);
		add_to_root_table(table,_focus_options_labels[i],_focus_options_help[i],o_table,i*2);
	}
	//mc focus-policy
	o_table = etk_table_new(1,3,FALSE);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set1 = etk_radio_button_new_with_label("CLICK",NULL)),0,0,0,0);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set2 = etk_radio_button_new_with_label_from_widget("MOUSE",ETK_RADIO_BUTTON(o_set1))),0,0,1,1);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set3 = etk_radio_button_new_with_label_from_widget("SLOPPY",ETK_RADIO_BUTTON(o_set1))),0,0,2,2);
	tmp = strcmp(getSetting(focus_options[i]),"MOUSE");
	if (tmp < 0)
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set1),TRUE);
	else if (tmp == 0)
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set2),TRUE);
	else
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set3),TRUE);
	etk_signal_connect("pressed",ETK_OBJECT(o_set1),ETK_CALLBACK(focus_mc),focus_options[i]);
	etk_signal_connect("pressed",ETK_OBJECT(o_set2),ETK_CALLBACK(focus_mc),focus_options[i]);
	etk_signal_connect("pressed",ETK_OBJECT(o_set3),ETK_CALLBACK(focus_mc),focus_options[i]);
	add_to_root_table(table,_focus_options_labels[i],_focus_options_help[i],o_table,i*2);
	i++;
	//mc focus-setting
	o_table = etk_table_new(1,4,FALSE);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set1 = etk_radio_button_new_with_label("NONE",NULL)),0,0,0,0);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set2 = etk_radio_button_new_with_label_from_widget("NEW_WINDOW",ETK_RADIO_BUTTON(o_set1))),0,0,1,1);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set3 = etk_radio_button_new_with_label_from_widget("NEW_DIALOG",ETK_RADIO_BUTTON(o_set1))),0,0,2,2);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_button = etk_radio_button_new_with_label_from_widget("NEW_DIALOG_IF_OWNER_FOCUSED",ETK_RADIO_BUTTON(o_set1))),0,0,3,3);
	tmpc = getSetting(focus_options[i]);
	if (!strcmp(tmpc,"NONE"))
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set1),TRUE);
	else if (!strcmp(tmpc,"NEW_WINDOW"))
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set2),TRUE);
	else if (!strcmp(tmpc,"NEW_DIALOG"))
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set3),TRUE);
	else
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_button),TRUE);
	etk_signal_connect("pressed",ETK_OBJECT(o_set1),ETK_CALLBACK(focus_mc),focus_options[i]);
	etk_signal_connect("pressed",ETK_OBJECT(o_set2),ETK_CALLBACK(focus_mc),focus_options[i]);
	etk_signal_connect("pressed",ETK_OBJECT(o_set3),ETK_CALLBACK(focus_mc),focus_options[i]);
	etk_signal_connect("pressed",ETK_OBJECT(o_button),ETK_CALLBACK(focus_mc),focus_options[i]);
	add_to_root_table(table,_focus_options_labels[i],_focus_options_help[i],o_table,i*2);
	i++;
	//auto-raise-1/0
	o_table = etk_table_new(1,1,FALSE);
	etk_table_attach(ETK_TABLE(o_table),get_prepared_toggle_button(focus_options[i])
		,0,0,0,0,0,0,ETK_FILL_POLICY_NONE);
	add_to_root_table(table,_focus_options_labels[i],_focus_options_help[i],o_table,i*2);
	i++;
	//auto-raise-delay
	add_to_root_table_swe(table,new_setting_with_entry(_focus_options_labels[i],focus_options[i],_focus_options_help[i]),i*2);
	
	etk_widget_show_all(window);
	return window;
}
