#include <Modules/menu.h>

char*
menu_settings[] = {
	"menu-autoscroll-margin",
	"menu-autoscroll-cursor-margin",
	"menus-scroll-speed",
	"menus-fast-move-threshold",
	"menus-click-drag-timeout",
	"menu-eap-name-show",
	"menu-eap-generic-show",
	"menu-eap-comment-show"
};

char*
_menu_settings_labels[] = {
	"<+ font_size=15>Autoscroll-Margin",
	"<+ font_size=15>Autoscroll-Cursor-Margin",
	"<+ font_size=15>Scroll-Speed",
	"<+ font_size=15>Fast-Move-Threshold",
	"<+ font_size=15>Click-Drag-Timeout",
	"<+ font_size=15>Eap-Name-Show",
	"<+ font_size=15>Eap-Generic-Show",
	"<+ font_size=15>Eap-Comment-Show"
};

char*
_menu_settings_help[] = {
	"Distance from edge, the menu will autoscroll to <br> ",
	"Distance from edge, the cursor needs to be to start autoscrolling <br> ",
	"Set the scroll speed of menus (pixels/sec) <br> ",
	"Mouse speed (pix/sec) that's considered a 'fast move' <br> ",
	"Time between press and release that'll keep menu up <br> ",
	"Show eapps' name field in menus <br> ",
	"Show eapps' generic field in menus <br> ",
	"Show eapps' comment field in menus"
};

Etk_Widget*
init_menu(){
	Etk_Widget *window,*container,*table;
	window = etk_window_new();
	etk_window_title_set(ETK_WINDOW(window),"Menu-Settings");
	etk_signal_connect_after("destroy",ETK_OBJECT(window),ETK_CALLBACK(sub_window_kill),NULL);
	
	container = etk_vbox_new(FALSE,3);
	etk_container_add(ETK_CONTAINER(window),container);

	table = etk_table_new(4, 16,FALSE);
	etk_container_add(ETK_CONTAINER(container),table);

	int i;
	for ( i = 0; i < 5; i++)
		add_to_root_table_swe(table,new_setting_with_entry(_menu_settings_labels[i],menu_settings[i],_menu_settings_help[i]),i*2);
	for ( i = 5; i < 8; i++){
		etk_table_attach_defaults(ETK_TABLE(table),etk_label_new(_menu_settings_labels[i]),0,0,i*2,i*2);
		etk_table_attach(ETK_TABLE(table),get_prepared_toggle_button(menu_settings[i]),1,1,i*2,i*2,0,0,ETK_FILL_POLICY_NONE);
		etk_table_attach_defaults(ETK_TABLE(table),etk_label_new(_menu_settings_help[i]),0,3,i*2+1,i*2+1);
	}
	
	etk_widget_show_all(window);
	return window;
}
