#include <Modules/window.h>

char*
window_options[] = {
	//(0/1)
	"move-info-visible",
	"move-info-follows",
	"resize-info-visible",
	"resize-info-follows",
	"border-shade-animate",
	//(val)
	"border-shade-speed",
	//(mc)
	"border-shade-transition",
	"maximize-policy",
	"window-placement-policy"
};

char *
_window_options_labels[] = {
	"Move-Info visible",
	"Move-Info follows",
	"Resize-Info visible",
	"Resize-Info follows",
	"Animate Border-Shade",
	"Border-Shade speed",
	"Border-Shade transition",
	"Maximize-Policy",
	"Window-placement-Policy"
},
*
_window_options_help[] = {
	"Display coordinates of window, while moving <br> ",
	"Display coordinates in middle of the window <br> ",
	"Display size of window, while resizing <br> ",
	"Display coordinates in middle of the window <br> ",
	"Show an animation when shading window <br> ",
	"How fast should the animation be (pix/sec) <br> ",
	"What kind of transition to be used (no function) <br> ",
	"How to maximize a window <br> ",
	"How to place a new window"
};

void
window_mc(Etk_Object *object, void *data){
	if (!object || !data)
		return;
	char* command = get_raw_command();
	strcat(command,data);
	strcat(command,"-set ");
	strcat(command,etk_button_label_get(ETK_BUTTON(object)));
	if (system(command))
		printf("Error executing command: `%s`\n",command);
}

Etk_Widget*
init_window(){
	Etk_Widget *window,*container,*table,*o_table,*o_set1,*o_set2,*o_set3,*o_set4;
	char* setting;
	int i;
	
	window = etk_window_new();
	etk_window_title_set(ETK_WINDOW(window),"Window Settings");
	etk_signal_connect_after("destroy",ETK_OBJECT(window),ETK_CALLBACK(sub_window_kill),NULL);
	
	container = etk_vbox_new(FALSE,3);
	etk_container_add(ETK_CONTAINER(window),container);
	
	table = etk_table_new(2,WINDOW_OPTIONS*2,FALSE);
	etk_container_add(ETK_CONTAINER(container),table);
	
	for (i=0;i<5;i++){
		o_table = etk_table_new(1,1,FALSE);
		etk_table_attach(ETK_TABLE(o_table),get_prepared_toggle_button(window_options[i])
			,0,0,0,0,0,0,ETK_FILL_POLICY_NONE);
		add_to_root_table(table,_window_options_labels[i],_window_options_help[i],o_table,i*2);
	}
	
	i = 5;
	add_to_root_table_swe(	table,
							new_setting_with_entry(	_window_options_labels[i],
													window_options[i],
													_window_options_help[i]),
							i*2);
	etk_table_attach_defaults(ETK_TABLE(table),etk_label_new(_window_options_help[i]),0,2,i*2+1,i*2+1);
	
	i++;
	o_table = etk_table_new(1,4,TRUE);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set1 = etk_radio_button_new_with_label("0",NULL))
		,0,0,0,0);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set2 = etk_radio_button_new_with_label_from_widget("1",ETK_RADIO_BUTTON(o_set1)))
		,0,0,1,1);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set3 = etk_radio_button_new_with_label_from_widget("2",ETK_RADIO_BUTTON(o_set1)) )
		,0,0,2,2);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set4 = etk_radio_button_new_with_label_from_widget("3",ETK_RADIO_BUTTON(o_set1)) )
		,0,0,3,3);
	setting = getSetting(window_options[i]);
	if (!strcmp(setting,"0"))
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set1),TRUE);
	else if (!strcmp(setting,"1"))
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set2),TRUE);
	else if (!strcmp(setting,"2"))
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set3),TRUE);
	else
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set4),TRUE);
	etk_signal_connect("pressed",ETK_OBJECT(o_set1),ETK_CALLBACK(window_mc),window_options[i]);
	etk_signal_connect("pressed",ETK_OBJECT(o_set2),ETK_CALLBACK(window_mc),window_options[i]);
	etk_signal_connect("pressed",ETK_OBJECT(o_set3),ETK_CALLBACK(window_mc),window_options[i]);
	etk_signal_connect("pressed",ETK_OBJECT(o_set4),ETK_CALLBACK(window_mc),window_options[i]);
	add_to_root_table(table,_window_options_labels[i],_window_options_help[i],o_table,i*2);
	
	i++;
	o_table = etk_table_new(1,4,TRUE);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set1 = etk_radio_button_new_with_label("FILL",NULL))
		,0,0,0,0);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set2 = etk_radio_button_new_with_label_from_widget("FULLSCREEN",ETK_RADIO_BUTTON(o_set1)))
		,0,0,1,1);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set3 = etk_radio_button_new_with_label_from_widget("SMART",ETK_RADIO_BUTTON(o_set1)) )
		,0,0,2,2);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set4 = etk_radio_button_new_with_label_from_widget("EXPAND",ETK_RADIO_BUTTON(o_set1)) )
		,0,0,3,3);
	setting = getSetting(window_options[i]);
	if (!strcmp(setting,"FILL"))
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set1),TRUE);
	else if (!strcmp(setting,"FULLSCREEN"))
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set2),TRUE);
	else if (!strcmp(setting,"SMART"))
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set3),TRUE);
	else
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set4),TRUE);
	etk_signal_connect("pressed",ETK_OBJECT(o_set1),ETK_CALLBACK(window_mc),window_options[i]);
	etk_signal_connect("pressed",ETK_OBJECT(o_set2),ETK_CALLBACK(window_mc),window_options[i]);
	etk_signal_connect("pressed",ETK_OBJECT(o_set3),ETK_CALLBACK(window_mc),window_options[i]);
	etk_signal_connect("pressed",ETK_OBJECT(o_set4),ETK_CALLBACK(window_mc),window_options[i]);
	add_to_root_table(table,_window_options_labels[i],_window_options_help[i],o_table,i*2);
	
	i++;
	o_table = etk_table_new(1,3,TRUE);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set1 = etk_radio_button_new_with_label("SMART",NULL))
		,0,0,0,0);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set2 = etk_radio_button_new_with_label_from_widget("CURSOR",ETK_RADIO_BUTTON(o_set1)))
		,0,0,1,1);
	etk_table_attach_defaults(ETK_TABLE(o_table),(o_set3 = etk_radio_button_new_with_label_from_widget("MANUAL",ETK_RADIO_BUTTON(o_set1)) )
		,0,0,2,2);
	setting = getSetting(window_options[i]);
	if (!strcmp(setting,"SMART"))
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set1),TRUE);
	else if (!strcmp(setting,"CURSOR"))
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set2),TRUE);
	else
		etk_toggle_button_active_set(ETK_TOGGLE_BUTTON(o_set3),TRUE);
	etk_signal_connect("pressed",ETK_OBJECT(o_set1),ETK_CALLBACK(window_mc),window_options[i]);
	etk_signal_connect("pressed",ETK_OBJECT(o_set2),ETK_CALLBACK(window_mc),window_options[i]);
	etk_signal_connect("pressed",ETK_OBJECT(o_set3),ETK_CALLBACK(window_mc),window_options[i]);
	add_to_root_table(table,_window_options_labels[i],_window_options_help[i],o_table,i*2);
	etk_table_attach_defaults(ETK_TABLE(table),etk_label_new(_window_options_help[i]),0,2,i*2+1,i*2+1);
	
	etk_widget_show_all(window);
	return window;
}
